var allPrimitives = new Array();
var rgbColor = new Array(255, 255, 255);
var hexColor = '#fff';
var selectedPrimitive;
var selectedPrimitiveBBox;
var canvas;
var sizer;
var group;
var start = function () {
	if (this.attrs.cx === undefined) {
		this.ox = parseInt(this.attr("x"));
	    this.oy = parseInt(this.attr("y"));
	} else {
		this.ox = parseInt(this.attr("cx"));
		this.oy = parseInt(this.attr("cy"));
	}
},
move = function (dx, dy) {
	removeBBox();

	if (this.attrs.cx === undefined) {
		this.attr({x: parseInt(this.ox) + parseInt(dx), y: parseInt(this.oy) + parseInt(dy)});
	} else {
		this.attr({cx: parseInt(this.ox) + parseInt(dx), cy: parseInt(this.oy) + parseInt(dy)});
	}

};

var sizerStart = function() {
	this.ox = this.attr("x");
	this.oy = this.attr("y");

	this.box.ow = this.box.attr("width");
	this.box.oh = this.box.attr("height");
},
sizerMove = function(dx, dy) {
	this.attr({x: parseInt(this.ox) + parseInt(dx), y: parseInt(this.oy) + parseInt(dy)});
	this.box.attr({width: this.box.ow + dx, height: this.box.oh + dy});
};

var startGroup = function() {
	this.group = Array();
	for (var i = 0; i < group.length; i++) {
		if (group[i].attrs.cx === undefined) {
			var primitive = {
				ox : parseInt(group[i].attr("x")),
				oy : parseInt(group[i].attr("y"))
			};
			this.group.push(primitive);
		} else {
			var primitive = {
				ox : parseInt(group[i].attr("cx")),
				oy : parseInt(group[i].attr("cy"))
			};
			this.group.push(primitive);
		}
	}
},
moveGroup = function(dx, dy) {
	for (var i = 0; i < group.length; i++) {
		group[i].attr({x: parseInt(this.group[i].ox) + parseInt(dx), y: parseInt(this.group[i].oy) + parseInt(dy)});
	}
};

$(document).ready(function () {
	initLayout();
	initSliders();
	initEvents();
	canvas = Raphael("canvas");
	
	addCircle();
	addEllipse();
	addRectangle();
	addTriangle();

	group = canvas.set();

	$('#canvas').on('click', function(event){
		var isGrouped = false;
		var selected = canvas.getElementByPoint(event.clientX, event.clientY);
		for (var i = 0; i < group.length; i++) {
			if (selected == group[i]) {
				isGrouped = true;
				selectedPrimitive = group;
			}
		}

		if (!isGrouped) {
			selectedPrimitive = canvas.getElementByPoint(event.clientX, event.clientY);
		}
		
		if (selectedPrimitive !== null && !selectedPrimitive.isSizer) {
			addBBox();
		} else {
			removeBBox();
		}
	});

	$('#remove-btn').on('click', function(){
		deleteSelectedPrimitive();
	});

	$('#add-group-btn').on('click', function(){
		group.push(selectedPrimitive);

		selectedPrimitive = group;
		removeBBox();

		addBBox();
		canvas.set(group).drag(moveGroup, startGroup);
	});
});

function addCircle() {
	$('#circle-primitive-btn').on('click', function(){
		var x = canvas.width / 2;
		var y = canvas.height / 2;

		var circle = canvas.circle(x, y, 10);
		circle.attr("fill", hexColor);
		circle.attr("stroke", "#000");
		circle.attr("fill-opacity", 50);

		allPrimitives.push(circle);
		canvas.set(circle).drag(move, start);
	});
}

function addEllipse() {
	$('#ellipse-primirive-btn').on('click', function(){
		var x = canvas.width / 2;
		var y = canvas.height / 2;

		var ellipse = canvas.ellipse(x, y, 30, 20);
		ellipse.attr("fill", hexColor);
		ellipse.attr("stroke", "#000");

		allPrimitives.push(ellipse);
		canvas.set(ellipse).drag(move, start);
	});
}

function addRectangle() {
	$('#rectangle-primirive-btn').on('click', function(){
		var x = canvas.width / 2;
		var y = canvas.height / 2;

		var rect = canvas.rect(x, y, 80, 60);
		rect.attr("fill", hexColor);
		rect.attr("stroke", "#000");

		allPrimitives.push(rect);
		canvas.set(rect).drag(move, start);
	});
}

function addTriangle() {
	$('#triangle-primirive-btn').on('click', function(){
		var triangle = canvas.path('M 50 0 L 100 100 L 0 100 Z').attr('fill', 'red');
		canvas.set(triangle).drag(move, start);
		allPrimitives.push(triangle);

		// createPolygon(304,200,100,300,100,600,500,0,'red');
	});
}

/*
M	moveto	(x y)+
Z	closepath	(none)
L	lineto	(x y)+
H	horizontal lineto	x+
V	vertical lineto	y+
C	curveto	(x1 y1 x2 y2 x y)+
S	smooth curveto	(x2 y2 x y)+
Q	quadratic Bézier curveto	(x1 y1 x y)+
T	smooth quadratic Bézier curveto	(x y)+
A	elliptical arc	(rx ry x-axis-rotation large-arc-flag sweep-flag x y)+
R	Catmull-Rom curveto*	x1 y1 (x y)+
*/

function createPolygon(x1,y1,x2,y2,x3,y3,x4,y4,color){
	canvas.path('M '+x1+' '+y1+' L '+x2+' '+y2+' L '+x3+' '+y3+' L '+x4+' '+y4+' Z').attr('fill',color);
	
		// //circle with lines
		// var x = canvas.width / 10;
		// var y = canvas.height / 10;
 	
 		
		// var circle = canvas.circle(x, y, 50);
		// circle.attr("fill", hexColor);
		// circle.attr("stroke", "#000");
		// circle.attr("fill-opacity", 50);

		// allPrimitives.push(circle);

		// var c = canvas.path("M90 10L140 100");
		// var d = canvas.path("M135 14L88 101");

		// //romb
		// var rect = canvas.rect(400, 400, 100, 100);
		// rect.rotate(45);

		
		// var circle2 = canvas.circle(429, 429, 5);
		// circle2 = circle2.attr("fill", "black");

		// var circle3 = canvas.circle(460, 428, 5);
		// circle3 = circle3.attr("fill", "black");

		// var e = canvas.path("M422 473L449 504L474 473");
}

function addBBox() {
	if (selectedPrimitiveBBox !== undefined)
		selectedPrimitiveBBox.remove();

	var bBox = selectedPrimitive.getBBox();
	
	selectedPrimitiveBBox = canvas.rect(bBox.x, bBox.y, bBox.width, bBox.height);
	selectedPrimitiveBBox.attr("stroke-dasharray", "- ");

	var sizer = addSizer();
	selectedPrimitive.sizer = sizer;
}

function removeBBox() {
	if (selectedPrimitiveBBox !== undefined)
		selectedPrimitiveBBox.remove();

	if (sizer !== undefined)
		sizer.remove();
}

function addSizer() {
	if (selectedPrimitiveBBox === undefined)
		return;

	var bBox = selectedPrimitive.getBBox();
	sizer = canvas.rect(bBox.x + (bBox.width - 10), bBox.y + (bBox.height - 10), 10, 10);
	sizer.attr("fill", "000");
	sizer.attr("opacity", 0.5);

	sizer.isSizer = true;

	sizer.box = selectedPrimitive;

	sizer.drag(sizerMove, sizerStart);
}

function initLayout() {
	var myLayout = $('#viewport').layout({
		//	reference only - these options are NOT required because 'true' is the default
			closable:					true	// pane can open & close
		,	resizable:					true	// when open, pane can be resized 
		,	slidable:					true	
		,	livePaneResizing:			true


		//	some pane-size settings
		,	west__minSize:				150
		,	west__resizable: true
		,	east__minSize:				300
		,	center__minWidth:			500
		,	center__resizable:			true
		,	east__resizable:			true

		//	disable state management
		,	stateManagement__enabled:	false // automatic cookie load & save enabled by default

		,	showDebugMessages:			true // log and/or display messages from debugging & testing code
	});
}

function initSliders() {
	$('#r-color').slider()
		.on('slide', function(ev){
			rgbColor[0] = ev.value;
			hexColor = rgbToHex(rgbColor[0], rgbColor[1], rgbColor[2]);
			updateSelectedPrimitiveColor();
  		});

  	$('#g-color').slider()
  		.on('slide', function(ev){
	    	rgbColor[1] = ev.value;
	    	hexColor = rgbToHex(rgbColor[0], rgbColor[1], rgbColor[2]);
	    	updateSelectedPrimitiveColor();
	  	});
  	$('#b-color').slider()
  		.on('slide', function(ev){
	    	rgbColor[2] = ev.value;
	    	hexColor = rgbToHex(rgbColor[0], rgbColor[1], rgbColor[2]);
	    	updateSelectedPrimitiveColor();
	  	});

  	$('.horizontal-slider').slider()
  		.on('slide', function(ev){
	    	updateSelectedPrimitiveOpacity(ev.value);
	  	});
}

function rgbToHex(r, g, b) {
    if(r < 0 || r > 255) alert("r is out of bounds; "+r);
    if(g < 0 || g > 255) alert("g is out of bounds; "+g);
    if(b < 0 || b > 255) alert("b is out of bounds; "+b);
    return "#" + ((1 << 24) + (r << 16) + (g << 8) + b).toString(16).slice(1,7);
}

function updateSelectedPrimitiveColor() {
	if (selectedPrimitive) {
		if ($('#selectStroke').hasClass('active')) {
			selectedPrimitive.attr("stroke", hexColor);	
		} else {
			selectedPrimitive.attr("fill", hexColor);		
		}
		
	}
	
}

function updateSelectedPrimitiveOpacity(value) {
	var opacity = value/100;
	selectedPrimitive.animate({ "fill-opacity": opacity });
}

function initEvents() {
	$('#rotate-btn').on('click', function(){
		rotateSelectedPrimitive($('#rotateAngle').val());
	});

	$('#save-btn').on('click', function(){
		var content = canvas.toSVG();
		saveAsFile(content);
	});

	$('#openfile-btn').on('click', function() {
		document.getElementById("fileToLoad").click();
	});

	$('html').keyup(function(e){
		if(e.keyCode == 46) {
			deleteSelectedPrimitive();
		}
	});

	$('#stroke-btn').on('click', function(){
		changeStrokeSelectedPrimitive($('#stroke').val());
	});

	$('#selectStroke').on('click', function(){
		if ($(this).hasClass('active') === false) {
			$(this).addClass('active');
		} else {
			$(this).removeClass('active');
		}
	});

	$('#new-btn').on('click', function(){
		canvas.clear();
	});
}

function rotateSelectedPrimitive(value) {
	selectedPrimitive.rotate(value);
}

function saveAsFile(content)
{
	//var textToWrite = document.getElementById("inputTextToSave").value;
	var textToWrite = content;
	var textFileAsBlob = new Blob([textToWrite], {type:'image/svg+xml'});
	var fileNameToSaveAs = Math.random().toString(36).substr(2) + ".svg";

	var downloadLink = document.createElement("a");
	downloadLink.download = fileNameToSaveAs;
	downloadLink.innerHTML = "Download File";
	if (window.webkitURL != null)
	{
		// Chrome allows the link to be clicked
		// without actually adding it to the DOM.
		downloadLink.href = window.webkitURL.createObjectURL(textFileAsBlob);
	}
	else
	{
		// Firefox requires the link to be added to the DOM
		// before it can be clicked.
		downloadLink.href = window.URL.createObjectURL(textFileAsBlob);
		downloadLink.onclick = destroyClickedElement;
		downloadLink.style.display = "none";
		document.body.appendChild(downloadLink);
	}

	downloadLink.click();
}

function destroyClickedElement(event)
{
	document.body.removeChild(event.target);
}

function loadFile()
{
	var fileToLoad = document.getElementById("fileToLoad").files[0];

	var fileReader = new FileReader();
	fileReader.onload = function(fileLoadedEvent) 
	{
		var textFromFileLoaded = fileLoadedEvent.target.result;
		//document.getElementById("canvas").innerHTML = textFromFileLoaded;
		canvas.clear();
		canvas.importSVG($.parseXML(textFromFileLoaded));
		canvas.forEach(function (el) {
		    canvas.set(el).drag(move, start);
		});
	};
	fileReader.readAsText(fileToLoad, "UTF-8");
}

function deleteSelectedPrimitive() {
	if (selectedPrimitive !== undefined) {
		selectedPrimitive.remove();
		selectedPrimitiveBBox.remove();
		sizer.remove();
	}
}

function changeStrokeSelectedPrimitive(value) {
	if (selectedPrimitive) {
		selectedPrimitive.attr("stroke-width", value);
	}
}